#ifndef __LitesqlFieldPanel__
#define __LitesqlFieldPanel__

/**
@file
Subclass of FieldPanel, which is generated by wxFormBuilder.
*/

#include <wx/valgen.h>

#include "ui.h"
#include "objectmodel.hpp"

/**Validator for a wxChoice <-> xml::Field::type */
class FieldTypeValidator : public wxGenericValidator {

  DECLARE_DYNAMIC_CLASS(FieldTypeValidator)

public:
  static const wxArrayString FIELDTYPES;

  
  FieldTypeValidator (xml::Field::Ptr val = xml::Field::Ptr(NULL));
  FieldTypeValidator (const FieldTypeValidator& val);

  virtual wxObject *Clone() const;
    
  // Called to transfer data to the window
  virtual bool TransferToWindow();

    // Called to transfer data from the window
  virtual bool TransferFromWindow();

private:
  xml::Field::Ptr m_pField;
  wxString value; 
};

/**Validator for a wxChoice <-> xml::Field::values */
class FieldValuesValidator : public wxValidator {

  DECLARE_DYNAMIC_CLASS(FieldValuesValidator)

public:
  FieldValuesValidator (xml::Field::Ptr val=xml::Field::Ptr(NULL));
  FieldValuesValidator (const FieldValuesValidator& val);

  virtual wxObject *Clone() const;
    
  // Called to transfer data to the window
  virtual bool TransferToWindow();

    // Called to transfer data from the window
  virtual bool TransferFromWindow();

private:
  xml::Field::Ptr m_pField;
};

class FieldIndexedValidator : public wxGenericValidator {

  DECLARE_DYNAMIC_CLASS(FieldIndexedValidator)

public:
  
  FieldIndexedValidator (xml::Field::Ptr val = xml::Field::Ptr(NULL));
  FieldIndexedValidator (const FieldIndexedValidator& val);

  virtual wxObject *Clone() const;
    
  // Called to transfer data to the window
  virtual bool TransferToWindow();

    // Called to transfer data from the window
  virtual bool TransferFromWindow();

private:
  xml::Field::Ptr m_pField;
  bool isIndexed; 
};

class FieldUniqueValidator : public wxGenericValidator {

  DECLARE_DYNAMIC_CLASS(FieldUniqueValidator)

public:
  
  FieldUniqueValidator  (xml::Field::Ptr val = xml::Field::Ptr(NULL));
  FieldUniqueValidator  (const FieldUniqueValidator & val);

  virtual wxObject *Clone() const;
    
  // Called to transfer data to the window
  virtual bool TransferToWindow();

    // Called to transfer data from the window
  virtual bool TransferFromWindow();

private:
  xml::Field::Ptr m_pField;
  bool isUnique; 
};

/** Implementing FieldPanel */
class LitesqlFieldPanel : public ui::FieldPanel
{
public:
	/** Constructor */
  LitesqlFieldPanel( wxWindow* parent , xml::Field::Ptr pField);

  xml::Field::Ptr GetField()          { return m_pField; }

protected:
  void OnAddValue( wxCommandEvent& event );
  void OnRemoveValue( wxCommandEvent& event );
  
private:
  LitesqlFieldPanel() : ui::FieldPanel(NULL) {};
  DECLARE_DYNAMIC_CLASS(LitesqlFieldPanel);
  
  xml::Field::Ptr m_pField;
  
};

#endif // __LitesqlFieldPanel__
